-- mvh 20120222	Added singleitem option
-- 				if set disable shoppingcart option in dicom.ini

local singleitem=true;

function split(str, pat)
   local t = {}
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end

function getstudyuid(patientid, seriesuid)
  local a,b,s;
  if CGI('source')=='(local)' then
    s = servercommand('get_param:MyACRNema')
  else
    s = CGI('source')
  end
  b=newdicomobject();
  b.PatientID = patientid;
  b.SeriesInstanceUID = seriesuid;
  b.StudyInstanceUID = '';
  b.Modality = '';
  a=dicomquery(s, 'SERIES', b);
  return a[0].StudyInstanceUID, a[0].Modality
end

function getstudyinfo(patientid, studyuid)
  local a,b,s;
  if CGI('source')=='(local)' then
    s = servercommand('get_param:MyACRNema')
  else
    s = CGI('source')
  end
  b=newdicomobject();
  b.PatientID = patientid;
  b.StudyInstanceUID = studyuid;
  b.StudyDate = '';
  b.StudyTime = '';
  b.StudyDescription = '';
  b['0008,0061']='';
  a=dicomquery(s, 'STUDY', b);
  return a[0].StudyDate, a[0]['0008,0061'], a[0].StudyDescription
end

HTML('Content-type: text/html\n\n');
HTML('<!-- Any SQL error messages will appear here:')

-- use the next statement for testing
-- sql('DROP TABLE MarkedScans')

sql([[
CREATE TABLE "MarkedScans" (
Key varchar(256),
Source varchar(32),
Mode varchar(32),
PatientID varchar(64),
StudyUID varchar(64),
SeriesUID varchar(64),
SopInstanceUID varchar(64),
AnonPatientID varchar(64),
AnonStudyUID varchar(64),
AnonSeriesUID varchar(64),
AnonSopInstanceUID varchar(64),
Status varchar(64),
Modality varchar(64),
StudyDate varchar(64),
StudyDescription varchar(64)
)]])

HTML('--!>')

local key, source, mtype, patientid, studyuid, seriesuid, sopuid;
local anonpatientid, anonstudyuid, anonseriesuid, anonsopuid;
local studydate, modality, studydescription, query;

key = CGI('key')
source = CGI('source')
seriesuid = ''
sopuid = ''
anonpatientid = ''
anonstudyuid = ''
anonseriesuid = ''
anonsopuid = ''

HTML('<H1>Conquest DICOM server version: '..version..'</H1>')
HTML('<H2>This data will be attached to the eCRF: </H2>')

if mode=='markstudy' then
  patientid = split(study, ':')[1];
  studyuid = split(study, ':')[2];

  anonpatientid = split(key, ':')[1]
  anonstudyuid = servercommand('changeuid:'..studyuid);

  HTML('<br>')
  HTML('PatientID = ' .. patientid)
  HTML('<br>')
  HTML('StudyInstanceUID = ' .. studyuid)

  HTML('<br>')
  HTML('<br>')
  HTML('Anonymized PatientID = ' .. anonpatientid)
  HTML('<br>')
  HTML('Anonymized StudyInstanceUID = ' .. anonstudyuid)
  studydate, modality, studydescription = getstudyinfo(patientid, studyuid)
elseif mode=='markseries' then
  patientid = split(series, ':')[1];
  seriesuid = split(series, ':')[2];
  studyuid, modality = getstudyuid(patientid, seriesuid)

  anonpatientid = split(key, ':')[1]
  anonstudyuid = servercommand('changeuid:'..studyuid);
  anonseriesuid = servercommand('changeuid:'..seriesuid);

  HTML('<br>')
  HTML('PatientID = ' .. patientid)
  HTML('<br>')
  HTML('StudyInstanceUID = ' .. studyuid)
  HTML('<br>')
  HTML('SeriesInstanceUID = ' .. seriesuid)
  HTML('<br>')
  HTML('<br>')
  HTML('Anonymized PatientID = ' .. anonpatientid)
  HTML('<br>')
  HTML('Anonymized StudyInstanceUID = ' .. anonstudyuid)
  HTML('<br>')
  HTML('Anonymized SeriesInstanceUID = ' .. anonseriesuid)
  local dum;
  studydate, dum, studydescription = getstudyinfo(patientid, studyuid)
end

HTML('<br>')
HTML('<br>')
HTML('Study date = ' .. studydate)
HTML('<br>')
HTML('Modality = ' .. modality)
HTML('<br>')
HTML('Description = ' .. studydescription)
HTML('<br>')

if singleitem then
  query = "key='".. key .."'"
  sql("DELETE FROM MarkedScans WHERE "..query);
end

query =
   "key='".. key .."'" ..
   " AND PatientID='" .. patientid .."'" ..
   " AND StudyUID='" .. studyuid .."'";
if seriesuid~='' then
  query = query .. " AND SeriesUID='".. seriesuid .."'";
end

HTML('<br>')
local q;
q = dbquery('MarkedScans', 'Status', query)[1];
if q then
  HTML('<H2>This data was marked before: '.. q[1] ..'</H2>')
  HTML('<br>')
else
  sql("INSERT INTO MarkedScans VALUES (" ..
  '"' .. key .. '",' ..
  '"' .. source .. '",' ..
  '"' .. mode .. '",' ..
  '"' .. patientid .. '",' ..
  '"' .. studyuid .. '",' ..
  '"' .. seriesuid .. '",' ..
  '"' .. sopuid .. '",' ..
  '"' .. anonpatientid .. '",' ..
  '"' .. anonstudyuid .. '",' ..
  '"' .. anonseriesuid .. '",' ..
  '"' .. anonsopuid .. '",' ..
  '"' ..'marked at ' .. os.date() .. '",' ..
  '"' .. studydate .. '",' ..
  '"' .. modality .. '",' ..
  '"' .. studydescription .. '"' ..
  ")"
  )
end

if singleitem then
--[[
	query = "key='".. key .."'"
	q = dbquery('MarkedScans', 'patientid, studyuid, seriesuid, source, modality, studydate, studydescription, status', query);
	HTML('<H2>This data has been selected: </H2>')
	for i=1, #q do
	  local key, value;
	  for key, value in ipairs(q[i]) do
		if #value > 70 then
		  HTML('UID not shown' .. ' ')
		else
		  HTML(value .. ' ')
		end
		if value~='' then
		  HTML('<br>')
		end
	  end
	  HTML('<hr>')
	end
]]--

	HTML('<br>')
	HTML('<br>')
	HTML('<A href=dgate.exe?mode=ecrfprocess&option=collect&key='..key..'>Collect data on local server</A>')
	HTML('<br>')
	HTML('<A href=dgate.exe?mode=ecrfprocess&option=submit&key='..key..'>Submit data to central server</A>')
	HTML('<br>')
	HTML('<A href=dgate.exe?mode=ecrfprocess&option=download&key='..key..'>Download information for eCRF</A>')
	HTML('<br>')
	HTML('<A href=dgate.exe?mode=ecrfprocess&option=remove&key='..key..'>Cancel this selection</A>')
end

